-- Magic restriction helper functions

GameObj.Meta.CanUseMagic = function (target)
	local restrictions = target:GetMagicRestrictions()
	return #restrictions == 0
end

GameObj.Meta.GetMagicRestrictions = function (target)
	return target:GetObjVar("MagicRestrictions") or {}
end

GameObj.Meta.AddMagicRestriction = function (target, name)
	local origin = target:GetMagicRestrictions()
	origin[#origin+1] = name
	target:SetObjVar("MagicRestrictions", origin)
end

GameObj.Meta.RemoveMagicRestriction = function (target, name)
	local origin = target:GetMagicRestrictions()
	for i,k in pairs(origin) do
		if k == name then
			table.remove(origin, i)
			break
		end
	end
	target:SetObjVar("MagicRestrictions", origin)
end