--[[
Arcanima Poisoning System overrides and stuff 
~Bensku Work
--]]
require "default:base_eating"

EatListeners = {}
BeforeEatListeners = {}

function EatFood(food, foodInfo)
	local canEat = true
	local prevented = ""
	for k,v in pairs(BeforeEatListeners) do
		local success = v(food, foodInfo)

		if success ~= true then
			canEat = false
			prevented = k
			break
		end
	end

	local result = "prevented"
	local reason = "Prevented by "..prevented
	if canEat == true then
		result, reason = EatFoodActual(food, foodInfo)
	end

	for k,v in pairs(EatListeners) do
		v(this, result, reason, food, foodInfo)
	end
end

function EatFoodActual(food, foodInfo) -- Copied and edited from Base build; needs to return something useful
 	--DebugMessage("Attempting to eat food " .. food:GetName())
	local myFull = this:GetObjVar("fullLevel")
	if(myFull == nil) then myFull = 0 end
	--D*ebugTable(foodInfo)
	local newFillAdd = foodInfo.fillingness
	--DebugMessage("Adding Filling: " ..tostring(type(newFillAdd)))
	local modEffect = 1
	if(newFillAdd == nil) then 
		DebugMessage("Invalid Fillingness")
		return "error", "Invalid Fillingness"
	end
	if(newFillAdd <= 0) then 
		DebugMessage("Fillingness Negative")
		return "error", "Fillingness Negative"
	end
	if((myFull > MAX_FULL_LEVEL) or ((newFillAdd + myFull) > FULL_CAP)) then
		this:SystemMessage("You couldn't possibly eat all that, no matter how greedy you are.[-]")
		return "alreadyFull"
	end
	if((newFillAdd + myFull) >= -3) then
		if(newFillAdd + myFull > MAX_FULL_LEVEL) then
			modEffect = math.max(.1, (newFillAdd - (MAX_FULL_LEVEL - (newFillAdd + myFull))) / newFillAdd)
		end
		--DebugMessage("Eating")
		local newFill = myFull + newFillAdd
		local newEffects = foodInfo.newEffects
		local newFoodEffects = {}
		if (newEffects ~= nil) then 		
			local consume = false
			local duration = 20--foodInfo.Duration 
			if(duration < 1) then 
				DebugMessage("Invalid food duration")
				return "error", "Invalid food duration"
			end
			for e, d in pairs(newEffects) do
				local curVal = 0
				if (mFoodBonuses[e] ~= nil) then
					curVal = mFoodBonuses[e]
				end
				local newVal = d
				if(d > 0) then
					newVal = d * modEffect
				end
		 		local newTot = newVal + curVal
		 		newFoodEffects[e] = newVal
		 		mFoodBonuses[e] = newTot
		 		consume = true
			end

			if(consume == true) then
				local nextTimer = TimeSpan.FromSeconds(duration)
				nextTimer = nextTimer.TotalMilliseconds
				local curTime = ServerTimeMs()
				mFoodEffects[food] = newFoodEffects
				mFoodEffects[food].timer = nextTimer + curTime
				this:SetObjVar("FoodBonuses", mFoodBonuses)
				this:SetObjVar("FoodEffects", mFoodEffects)
				this:SetObjVar("fullLevel", newFill)
				food:Destroy()
				this:SystemMessage("You feel less hungry")
				this:SendMessage("AteFood", { newFill })
				this:ScheduleTimerDelay(TimeSpan.FromSeconds(2), "HungryStatusTimer")
				this:ScheduleTimerDelay(TimeSpan.FromSeconds(2), "FoodEffectTimer")
				--DebugMessage("Ate Food")
				--D*ebugTable(mFoodBonuses)
				ApplyFoodBonuses()
			end
		else
			--DebugMessage("No Food Effects Applied")
			--DebugMessage("Eating " .. food:GetName() .. " Full Level " ..(newFillAdd + myFull))
			this:SystemMessage("You feel less hungry")
			food:RequestRemoveFromStack(1)
			this:SetObjVar("fullLevel", newFill)
			this:SendMessage("AteFood", { newFill })
			this:ScheduleTimerDelay(TimeSpan.FromSeconds(1), "HungryStatusTimer")
			this:ScheduleTimerDelay(TimeSpan.FromSeconds(1), "FoodEffectTimer")
		end
	end

	return "success"
end

-- Hooks into food
require "food_apply_status"