local UserListPage = 1

function ShowUserList(selectedUser)
	local newWindow = DynamicWindow("UserList","Player List",660,300)
	local x = 20
	local y = 10
	local rowIndex = 1
	local itemsPerPage = 18
	local startIndex = ((UserListPage-1) * itemsPerPage) + 1
	local commandIndex = 1
	found = FindObjects(SearchUser(),GameObj(0))
	for i, obj in pairs(found) do
			if( commandIndex >= startIndex and commandIndex < startIndex + itemsPerPage) then
				tooltip = ""
				if(obj == selectedUser) then
					newWindow:AddButton(x, y, "select:"..obj:GetObjVar("actualName"),"[FF0000]"..StripColorFromString(selectedUser:GetName()).."[-]", 200, 0, "", "", false)
				else
					newWindow:AddButton(x, y, "select:"..obj:GetObjVar("actualName"), obj:GetName(), 200, 0, "", "", false)
				end
				if( rowIndex == 3 ) then
					x = 20
					y = y + 30
					rowIndex = 1
				else
					x = x + 200
					rowIndex = rowIndex + 1
				end
			end
			commandIndex = commandIndex + 1
	end
	
	newWindow:AddButton(10,210, "teleport:"..selectedUser:GetObjVar("actualName"), "teleport to",150,0, "", "", false)
	newWindow:AddButton(160,210, "teleportToMe:"..selectedUser:GetObjVar("actualName"), "teleport to me",150,0, "", "", false)
	newWindow:AddButton(310,210, "heal:"..selectedUser:GetObjVar("actualName"), "heal",150,0, "", "", false)
	newWindow:AddButton(460,210, "resurrect:"..selectedUser:GetObjVar("actualName"), "resurrect",150,0, "", "", false)
	
	if( UserListPage > 1 ) then
		newWindow:AddButton(380, 260, "UserListPrev:"..selectedUser:GetObjVar("actualName"), "Previous", 100, 0, "", "", false)
	end
	if( UserListPage <= (commandIndex-1) / itemsPerPage) then
		newWindow:AddButton(490, 260, "UserListNext:"..selectedUser:GetObjVar("actualName"), "Next", 100, 0, "", "", false)
	end
	this:OpenDynamicWindow(newWindow)
end

RegisterEventHandler(EventType.DynamicWindowResponse,"UserList",
	function (user,returnId)
		if(returnId ~= nil) then
			action, playerId = string.match(returnId, "(%a+):(%a+)")
			local playerObj = GetPlayerByNameOrId(playerId)
			if(action== "teleport") then
				if( playerObj ~= nil ) then
					this:SetWorldPosition(playerObj:GetLoc())
					this:PlayEffect("TeleportToEffect")
				end
			elseif(action== "teleportToMe") then
				if( playerObj ~= nil ) then
					playerObj:PlayEffect("TeleportFromEffect")
					playerObj:SetWorldPosition(this:GetLoc())
					playerObj:PlayEffect("TeleportToEffect")
				end
			elseif(action== "select") then
				local playerObj = GetPlayerByNameOrId(playerId)
				ShowUserList(playerObj)
			elseif(action=="heal") then
				local curHealth = math.floor(playerObj:GetCurHealth())
				local healAmount = playerObj:GetMaxHealth() - curHealth
				playerObj:SetCurHealth(curHealth + healAmount)
				playerObj:PlayEffect("HealEffect")
			elseif(action== "resurrect") then
				if( playerObj ~= nil ) then
					playerObj:SendMessage("Ressurect",1.0)
				end
			elseif(action == "UserListNext") then
			UserListPage = UserListPage + 1
			ShowUserList(playerObj)
			elseif( action == "UserListPrev") then
				UserListPage = UserListPage - 1
				ShowUserList(playerObj)
			end
		end	
	end)

ModedCommandFuncs= 
{
	Whod2 = function ()
		ShowUserList(this)
	end,
}
RegisterCommand{ Command="whod2", AccessLevel = AccessLevel.God, Func=ModedCommandFuncs.Whod2, Desc="List of online users with possibility to teleport to their location" }
