--UI_ColorShift.lua

Color="FF0000"
Object = nil
RGB={}
HSL={}
Modelist={"[FFFF00]Manual[-]", "[FF0000]Continuous[-]"}
Mode=1


if ac_commands==nil then 
	ac_commands={}
end
--pickColor is in HexString (FFFFFF)
ac_commands.ShowColorEditWindow = function (target,pickColor)
	tgtColor = target:GetHue()
	title = target:GetName()
	Object=target

	-- get a default color
	if pickColor==nil then pickColor=Color end
	Color=pickColor

	
	-- Get some numbers
	RGB = Hex2Rgb(pickColor)
	HSL = Hex2Hsl(pickColor)

	-- Get color components
	Hue=HSL.h
	Saturation=HSL.s
	Luminosity=HSL.l
	Red=RGB.r
	Green=RGB.g
	Blue=RGB.b


	ColorEditor = DynamicWindow("ColorEditor",title,800,600)

	dX=290
	dY=320

	-- Pick From
	ColorEditor:AddButton(dX+10,dY+10,"PickColor","Pick",65,65,"Choose an object to pick the color from.",nil,false)

	-- Target
	ColorEditor:AddButton(dX+10,dY+80,"SetTargetObj","Target",65,65,"Choose a new target object to edit.",nil,false)

	--Object Name
	ColorEditor:AddTextField(dX+10, dY+150, 470, "Name",target:GetName())
	--ToolTipString
	ColorEditor:AddTextField(dX+10, dY+190, 470, "TooltipString",target:GetSharedObjectProperty("TooltipString"))



	-- Show Current Picked Color
	ColorEditor:AddLabel(dX+90,dY+33,"Picked: ["..pickColor.."]"..pickColor.."[-]",200,65, 24 )

	-- Show Current target Color
	ColorEditor:AddLabel(dX+90,dY+103,"Target: ["..tgtColor.."]"..tgtColor.."[-]",200,65, 24 )

	-- Drop Color on Target
	ColorEditor:AddButton(dX+240,dY+80,"DropColor","Drop",65,65,"Drop picked color on chosen target.",nil,false)		

	-- Continuous Update
	ColorEditor:AddButton(dX+330,dY+80,"SelectMode",Modelist[Mode],130,65,"Toggle update mode for selected target.",nil,false)		



	-- 
	dX=300
	dY=10
	ColorEditor:AddLabel (dX ,dY+10, "Hex:",60,35, 21 )	
	ColorEditor:AddTextField(dX+60, dY+10, 90, "ColorCode",pickColor)
	ColorEditor:AddButton(dX+160,dY+5, "SetColorCode", "Set", 35,35, "Set color code to field value.",nil, false)
	

	----------------------------------
	-- Color Manipulators
	----------------------------------
	dX=300
	dY=60
	ColorEditor:AddLabel (dX +305,dY-20, "Manual Edit",160,35, 21 )	
	-- Add H Manipulators
	ColorEditor:AddLabel (dX+  0,dY+15, "Hue:",60,35, 21 )	
	ColorEditor:AddButton(dX+ 60,dY+10, "HueMin10" , "-10", 35,35, "Reduce Hue by 10 Deg."  ,nil, false)
	ColorEditor:AddButton(dX+100,dY+10, "HueMin05" , "- 5", 35,35, "Reduce Hue by 5 Deg."   ,nil, false)
	ColorEditor:AddButton(dX+140,dY+10, "HueMin01" , "- 1", 35,35, "Reduce Hue by 1 Deg."   ,nil, false)
	ColorEditor:AddButton(dX+180,dY+10, "HuePlus01", "+ 1", 35,35, "Increase Hue by 1 Deg." ,nil, false)
	ColorEditor:AddButton(dX+220,dY+10, "HuePlus05", "+ 5", 35,35, "Increase Hue by 5 Deg." ,nil, false)
	ColorEditor:AddButton(dX+260,dY+10, "HuePlus10", "+10", 35,35, "Increase Hue by 10 Deg.",nil, false)
	ColorEditor:AddTextField(dX+300,dY+15, 90, "Hue",tostring(Hue))
	ColorEditor:AddButton(dX+395,dY+10, "SetHue", "Set", 35,35, "Set Hue to Field Value",nil, false)

	-- Add S Manipulators
	ColorEditor:AddLabel (dX+  0,dY+55, "Sat:",60,35, 21 )	
	ColorEditor:AddButton(dX+ 60,dY+50, "SatMin10" , "-10", 35,35, "Reduce Saturation by 10%"  ,nil, false)
	ColorEditor:AddButton(dX+100,dY+50, "SatMin05" , "- 5", 35,35, "Reduce Saturation by 5%"   ,nil, false)
	ColorEditor:AddButton(dX+140,dY+50, "SatMin01" , "- 1", 35,35, "Reduce Saturation by 1%"   ,nil, false)
	ColorEditor:AddButton(dX+180,dY+50, "SatPlus01", "+ 1", 35,35, "Increase Saturation by 1%" ,nil, false)
	ColorEditor:AddButton(dX+220,dY+50, "SatPlus05", "+ 5", 35,35, "Increase Saturation by 5%" ,nil, false)
	ColorEditor:AddButton(dX+260,dY+50, "SatPlus10", "+10", 35,35, "Increase Saturation by 10%",nil, false)
	ColorEditor:AddTextField(dX+300,dY+55, 90, "Saturation",tostring(Saturation))
	ColorEditor:AddButton(dX+395,dY+50, "SetSaturation", "Set", 35,35, "Set Hue to Field Value",nil, false)
	-- Add L Manipulators
	ColorEditor:AddLabel (dX+  0,dY+95, "Lum:",60,35, 21 )	
	ColorEditor:AddButton(dX+ 60,dY+90, "LumMin10" , "-10", 35,35, "Reduce Luminosity by 10%"  ,nil, false)
	ColorEditor:AddButton(dX+100,dY+90, "LumMin05" , "- 5", 35,35, "Reduce Luminosity by 5%"   ,nil, false)
	ColorEditor:AddButton(dX+140,dY+90, "LumMin01" , "- 1", 35,35, "Reduce Luminosity by 1%"   ,nil, false)
	ColorEditor:AddButton(dX+180,dY+90, "LumPlus01", "+ 1", 35,35, "Increase Luminosity by 1%" ,nil, false)
	ColorEditor:AddButton(dX+220,dY+90, "LumPlus05", "+ 5", 35,35, "Increase Luminosity by 5%" ,nil, false)
	ColorEditor:AddButton(dX+260,dY+90, "LumPlus10", "+10", 35,35, "Increase Luminosity by 10%",nil, false)
	ColorEditor:AddTextField(dX+300,dY+95, 90, "Luminosity",tostring(Luminosity))
	ColorEditor:AddButton(dX+395,dY+90, "SetLuminosity", "Set", 35,35, "Set Hue to Field Value",nil, false)
	-- Add R Manipulators
	ColorEditor:AddLabel (dX+  0,dY+145, "[FF0000]Red:",60,35, 21 )	
	ColorEditor:AddButton(dX+ 60,dY+140, "RedMin10" , "[FF0000]-10", 35,35, "Reduce Red by 10"  ,nil, false)
	ColorEditor:AddButton(dX+100,dY+140, "RedMin05" , "[FF0000]- 5", 35,35, "Reduce Red by 5"   ,nil, false)
	ColorEditor:AddButton(dX+140,dY+140, "RedMin01" , "[FF0000]- 1", 35,35, "Reduce Red by 1"   ,nil, false)
	ColorEditor:AddButton(dX+180,dY+140, "RedPlus01", "[FF0000]+ 1", 35,35, "Increase Red by 1" ,nil, false)
	ColorEditor:AddButton(dX+220,dY+140, "RedPlus05", "[FF0000]+ 5", 35,35, "Increase Red by 5" ,nil, false)
	ColorEditor:AddButton(dX+260,dY+140, "RedPlus10", "[FF0000]+10", 35,35, "Increase Red by 10",nil, false)
	ColorEditor:AddTextField(dX+300,dY+145, 90, "Red",tostring(Red))
	ColorEditor:AddButton(dX+395,dY+140, "SetRed", "Set", 35,35, "Set Hue to Field Value",nil, false)
	-- Add G Manipulators
	ColorEditor:AddLabel (dX+  0,dY+185, "[00FF00]Green:",60,35, 21 )	
	ColorEditor:AddButton(dX+ 60,dY+180, "GreenMin10" , "[00FF00]-10", 35,35, "Reduce Green by 10"  ,nil, false)
	ColorEditor:AddButton(dX+100,dY+180, "GreenMin05" , "[00FF00]- 5", 35,35, "Reduce Green by 5"   ,nil, false)
	ColorEditor:AddButton(dX+140,dY+180, "GreenMin01" , "[00FF00]- 1", 35,35, "Reduce Green by 1"   ,nil, false)
	ColorEditor:AddButton(dX+180,dY+180, "GreenPlus01", "[00FF00]+ 1", 35,35, "Increase Green by 1" ,nil, false)
	ColorEditor:AddButton(dX+220,dY+180, "GreenPlus05", "[00FF00]+ 5", 35,35, "Increase Green by 5" ,nil, false)
	ColorEditor:AddButton(dX+260,dY+180, "GreenPlus10", "[00FF00]+10", 35,35, "Increase Green by 10",nil, false)
	ColorEditor:AddTextField(dX+300,dY+185, 90, "Green",tostring(Green))
	ColorEditor:AddButton(dX+395,dY+180, "SetGreen", "Set", 35,35, "Set Hue to Field Value",nil, false)
	-- Add B Manipulators
	ColorEditor:AddLabel (dX+  0,dY+225, "[6666FF]Blue:",60,35, 21 )	
	ColorEditor:AddButton(dX+ 60,dY+220, "BlueMin10" , "[6666FF]-10", 35,35, "Reduce Blue by 10"  ,nil, false)
	ColorEditor:AddButton(dX+100,dY+220, "BlueMin05" , "[6666FF]- 5", 35,35, "Reduce Blue by 5"   ,nil, false)
	ColorEditor:AddButton(dX+140,dY+220, "BlueMin01" , "[6666FF]- 1", 35,35, "Reduce Blue by 1"   ,nil, false)
	ColorEditor:AddButton(dX+180,dY+220, "BluePlus01", "[6666FF]+ 1", 35,35, "Increase Blue by 1" ,nil, false)
	ColorEditor:AddButton(dX+220,dY+220, "BluePlus05", "[6666FF]+ 5", 35,35, "Increase Blue by 5" ,nil, false)
	ColorEditor:AddButton(dX+260,dY+220, "BluePlus10", "[6666FF]+10", 35,35, "Increase Blue by 10",nil, false)
	ColorEditor:AddTextField(dX+300,dY+225, 90, "Blue",tostring(Blue))
	ColorEditor:AddButton(dX+395,dY+220, "SetBlue", "Set", 35,35, "Set Hue to Field Value",nil, false)

	----------------------------------	
	-- Color Swatches List
	----------------------------------	
	dX=30
	dY=10
	ColorEditor:AddLabel(dX,dY,"Color swatches:",200,35, 24 )	
	swatches = ScrollWindow(dX,dY+35, 220, 500, 35)
		-- use global colortable
	for color, value in pairsByKeys(COLORS) do
		SE=ScrollElement()
		SE:AddButton(0,0,"swatch"..value,"["..value.."]"..color.."[-]",200,0,color..":"..value.."[-]",nil,false,"SimpleButton")
		swatches:Add(SE)
	end
	ColorEditor:AddScrollWindow(swatches)


	this:OpenDynamicWindow(ColorEditor)
end





ac_commands.ColorEdit = function()
		this:RequestClientTargetGameObj(this,"EditObjectColor")
	end

ac_commands.DoColorEdit = function(target, user)
		color = target:GetHue()
		--user:SystemMessage(Arcanima.Color.Status.."#"..color.." from "..tostring( target:GetName() )  )
		ac_commands.ShowColorEditWindow(target)
	end

RegisterCommand{ Command="ce",  AccessLevel = AccessLevel.God, Func=ac_commands.ColorEdit, Desc="Edit object color." }

RegisterEventHandler(EventType.ClientTargetGameObjResponse, "EditObjectColor", 	ac_commands.DoColorEdit)


----------------------------------------------------
-- Handle window responses here 
----------------------------------------------------
RegisterEventHandler(EventType.DynamicWindowResponse,"ColorEditor",
	function(user, buttonId, data)
		-- Debug
		--user:SystemMessage(Arcanima.Color.Status.."ColorEditor Response ....."..user:GetName().." pressed "..buttonId)

		Object:SetName(data.Name)
		Object:SetSharedObjectProperty("TooltipString",data.TooltipString)

		newColor = Color

		-- check if a swatch was used and adjust parameters
		if string.sub(buttonId,1,6) == "swatch" then
			--DebugMessage("Swatch pressed")
			newColor=string.sub(buttonId,7,12)
			buttonId="Swatch"
		end

		-- responses
		responses={
			PickColor =	function() 
				this:RequestClientTargetGameObj(this,"PickColor")
			end,
			
			DropColor = function() 
				Object:SetHue(Color)
			end,

			SelectMode=function() 
				if Mode==1 then Mode=2 Object:SetHue(Color)
					else Mode=1
				end
			end,
			
			SetTargetObj = function()
				this:RequestClientTargetGameObj(this,"PickTarget")
			end,

			SetColorCode = function()
				newColor= data.ColorCode
			end,

			Swatch = function() 
				-- just a dummy. Work was done before
			end, 
			
			SetHue = function()
				HSL.h = data.Hue
				newColor=Hsl2Hex(HSL)
			end,
			HueMin01=function() 
				HSL.h = (HSL.h-1)%360
				newColor=Hsl2Hex(HSL)
			end,
			HueMin05=function()  
				HSL.h = (HSL.h-5)%360
				newColor=Hsl2Hex(HSL)
			end,
			HueMin10=function()  
				HSL.h = (HSL.h-10)%360
				newColor=Hsl2Hex(HSL)
			end,
			HuePlus01=function()  
				HSL.h = (HSL.h+1)%360
				newColor=Hsl2Hex(HSL)
			end,
			HuePlus05=function()  
				HSL.h = (HSL.h+5)%360
				newColor=Hsl2Hex(HSL)
			end,
			HuePlus10=function()  
				HSL.h = (HSL.h+10)%360
				newColor=Hsl2Hex(HSL)
			end,

			--- Saturation
			SetSaturation = function()
				HSL.s = data.Saturation
				newColor=Hsl2Hex(HSL) 
			end,
			SatMin01=function() 
				HSL.s = math.max(HSL.s-0.01,0)
				newColor=Hsl2Hex(HSL)
			end,
			SatMin05=function() 
				HSL.s = math.max(HSL.s-0.05,0)
				newColor=Hsl2Hex(HSL)
			end,
			SatMin10=function() 
				HSL.s = math.max(HSL.s-0.10,0)
				newColor=Hsl2Hex(HSL)
			end,
			SatPlus01=function() 
				HSL.s = math.min(HSL.s+0.01,1)
				newColor=Hsl2Hex(HSL)
			end,
			SatPlus05=function() 
				HSL.s = math.min(HSL.s+0.05,1)
				newColor=Hsl2Hex(HSL)
			end,
			SatPlus10=function() 
				HSL.s = math.min(HSL.s+0.10,1)
				newColor=Hsl2Hex(HSL)
			end,

			-- Luminosity
			SetLuminosity = function() 
				HSL.l = data.Luminosity
				newColor=Hsl2Hex(HSL) 
			end,
			LumMin01=function() 
				HSL.l = math.max(HSL.l-0.01,0)
				newColor=Hsl2Hex(HSL)
			end,
			LumMin05=function() 
				HSL.l = math.max(HSL.l-0.05,0)
				newColor=Hsl2Hex(HSL)
			end,
			LumMin10=function() 
				HSL.l = math.max(HSL.l-0.10,0)
				newColor=Hsl2Hex(HSL)
			end,
			LumPlus01=function() 
				HSL.l = math.min(HSL.l+0.01,1)
				newColor=Hsl2Hex(HSL)
			end,
			LumPlus05=function() 
				HSL.l = math.min(HSL.l+0.05,1)
				newColor=Hsl2Hex(HSL)
			end,
			LumPlus10=function() 
				HSL.l = math.min(HSL.l+0.10,1)
				newColor=Hsl2Hex(HSL)
			end,
			-- Red
			SetRed = function() 
				RGB.r = data.Red
				newColor=Rgb2Hex(RGB) 
			end,
			RedMin01=function() 
				RGB.r = math.max(RGB.r-1,0)
				newColor=Rgb2Hex(RGB)
			end,
			RedMin05=function() 
			RGB.r = math.max(RGB.r-5,0)
				newColor=Rgb2Hex(RGB)
			end,
			RedMin10=function() 
			RGB.r = math.max(RGB.r-10,0)
				newColor=Rgb2Hex(RGB)
			end,
			RedPlus01=function() 
				RGB.r = math.min(RGB.r+1,255)
				newColor=Rgb2Hex(RGB)
			end,
			RedPlus05=function() 
				RGB.r = math.min(RGB.r+5,255)
				newColor=Rgb2Hex(RGB)
			end,
			RedPlus10=function() 
				RGB.r = math.min(RGB.r+10,255)
				newColor=Rgb2Hex(RGB)
			end,

			-- Green
			SetGreen = function() 
				RGB.g = data.Green
				newColor=Rgb2Hex(RGB) 
			end,
			GreenMin01=function() 
				RGB.g = math.max(RGB.g-1,0)
				newColor=Rgb2Hex(RGB)
			end,
			GreenMin05=function() 
				RGB.g = math.max(RGB.g-5,0)
				newColor=Rgb2Hex(RGB)
			end,
			GreenMin10=function() 
				RGB.g = math.max(RGB.g-10,0)
				newColor=Rgb2Hex(RGB)
			end,
			GreenPlus01=function() 
				RGB.g = math.min(RGB.g+1,255)
				newColor=Rgb2Hex(RGB)
			end,
			GreenPlus05=function() 
				RGB.g = math.min(RGB.g+5,255)
				newColor=Rgb2Hex(RGB)
			end,
			GreenPlus10=function() 
				RGB.g = math.min(RGB.g+10,255)
				newColor=Rgb2Hex(RGB)
			end,
			-- Blue
			SetBlue = function() 
				RGB.b = data.Blue
				newColor=Rgb2Hex(RGB) 
			end,
			BlueMin01=function() 
				RGB.b = math.max(RGB.b-1,0)
				newColor=Rgb2Hex(RGB)
			end,
			BlueMin05=function() 
				RGB.b = math.max(RGB.b-5,0)
				newColor=Rgb2Hex(RGB)
			end,
			BlueMin10=function() 
				RGB.b = math.max(RGB.b-10,0)
				newColor=Rgb2Hex(RGB)
			end,
			BluePlus01=function() 
				RGB.b = math.min(RGB.b+1,255)
				newColor=Rgb2Hex(RGB)
			end,
			BluePlus05=function() 
				RGB.b = math.min(RGB.b+5,255)
				newColor=Rgb2Hex(RGB)
			end,
			BluePlus10=function() 
				RGB.b = math.min(RGB.b+10,255)
				newColor=Rgb2Hex(RGB)
			end
		}
		-- call response function
		responses[buttonId]()
		-- update
		Color=newColor
		--update
		if Mode==2 then
			Object:SetHue(Color)
		end

		-- TODO: Do a delayed update
		--ac_commands.ShowColorEditWindow(Object,Color)
		this:ScheduleTimerDelay(TimeSpan.FromMilliseconds(100),"DelayedUpdate",Object,Color)
	end)

RegisterEventHandler(EventType.ClientTargetGameObjResponse,"PickTarget",
	function(target,user)
		if Mode==2 then
			target:SetHue(Color)
		end
		ac_commands.ShowColorEditWindow(target,Color)
	end)

RegisterEventHandler(EventType.ClientTargetGameObjResponse,"PickColor",
	function(target,user)
		if Mode==2 then
			Object:SetHue(target:GetHue())
		end
		ac_commands.ShowColorEditWindow(Object,target:GetHue())
	end)

RegisterEventHandler(EventType.Message, "OpenColorEditor", -- Needed for NPC editor color pickings
	function (target, pickColor)
		if this:IsGod() then
			ac_commands.ShowColorEditWindow(target, pickColor)
		end
	end)

	-- Delayed Update
	RegisterEventHandler(EventType.Timer,"DelayedUpdate", 
		function(PObjRef,PColor)
			--DebugMessageF("PObjRef %s, PColor %s",PObjRef,PColor)
			ac_commands.ShowColorEditWindow(PObjRef,PColor)
		end)