require 'default:shard_time_controller'

-- OVERRIDING
UnregisterEventHandler('default:shard_time_controller',EventType.Message,"SetTime")
RegisterEventHandler(EventType.Message,"SetTime",
	function(args)		
		local hours,minutes = table.unpack(args)
		
		--DebugMessage("Attempt time change")
		if( minutes == nil ) then minutes = 0 end

		-- offset by 6 hours so a 12 hour day begins at 6am instead of noon
		local gameTimeHours = (hours + (minutes/60)) - DEFAULT_DAYLIGHT_START_OFFSET
		if( gameTimeHours < 0 ) then
			gameTimeHours = 24 + gameTimeHours
		end

		local gameTimePct = gameTimeHours / 24		

		-- get current time with no offset
		local currentTimePct = GetTimeOfDayPct(0)

		local offsetPct = gameTimePct - currentTimePct
		local offsetSecs = offsetPct * GetTotalDayDurationSecs()

		DebugMessage("SETTING OFFSET "..tostring(offsetSecs))

		this:SetObjVar("ShardTimeOffset",offsetSecs)


		--- Resetting cron object to new time
			local cronObj = FindObject(SearchModule("cron"))
			if (cronObj==nil) then
					DebugMessage("SetTime Command: No Cron Object found to rebuild")
				else
					DebugMessage("SetTime: Cron object found at: "..cronObj.Id)
					cronObj:FireTimer("Midnight",{"SetTime"})
			end


		BroadcastTimeUpdate()
	end)