  
require 'base_ai_mob'
--require 'incl_regions'
--require 'base_aging'
AI.Settings = {
        Age = 10, --Approximate age of the mob in years. Scale is set to a a tenth of this value        
        AggroChanceAnimals = 5, --1 out of this number chance to attack other animals
        AggroRange = 15.0, --Range to start aggroing
        CanFlee = true, --Determines if this mob should ever run away
        ChargeSpeed = 4.0, --Speed mob charges at target
        ChaseRange = 15.0, --distance from self to chase target
        CanTaunt = false, --Determines if this mob should taunt the target
        CanHowl = true, --Determines if this mob should stop and howl
        CanSpeak = false, --Determines if this mob speaks
        CanCast = false, --Determines if this mob should cast or not
        CanUseCombatAbilities = false,
        ChanceToNotAttackOnAlert = 2, --1 out of this number chance to attack when alerted
        Debug = true, --Turn debug messages on or off
        FleeDistance = 50, --Distance to run away when fleeing
        FleeChance = 20, 
        InjuredPercent = 0.1, --Percentage of health to run away
        FleeSpeed = 4, --speed to run away
        Leash = false, --Determines if this mob should ever leash
        LeashDistance = 400, --Max distance from spawn this mob should ever go
        CanWander = true, --Determines if this mob wanders or not
        WanderChance = 90, -- Chance to wander
        ScaleToAge = true,
        AgeScaleModifier = 1.15, --Determines if this mob should be scaled to age
        AgeHealthModifier = .125,
        --Following variables are unused if the previous one is set to true
        ScaleRange = 4, --Maximum range to simulate scale randomization. 
        --Following variables are overridden if RandomizeScale or ScaleToAge is true
        AgeCheckFrequencySecs = 60*15, -- How often should the mobs age change
        MaxAge = 18, --Maximum age before mob starts to die of old age.
        MaxAgeScale = 1.5, --Maximum scale that a mob can age.
        AgeIncrement = 0.4, -- The amount a mob ages every time its checked
    }


AI.Settings.Debug = true



AI.StateMachine.AllStates.Idle = 
{   
    GetPulseFrequencyMS = 
        function() 
            return 1000 
        end,

    OnEnterState = 
        function ()
            AI.StateMachine.ChangeState("Wander")
        end,

    AiPulse = 
        function()
            AI.StateMachine.ChangeState("Wander")
        end
}


AI.StateMachine.AllStates.Howl  = 
{
    GetPulseFrequencyMS = 
        function() 
            return 1000 
        end,
        
    OnEnterState = 
        function()
            this:StopMoving()
            this:PlayAnimation("howl")
            this:PlayObjectSound("WerewolfRoar")    
        end,

    AiPulse = 
        function()
            if (AI.MainTarget == nil) then
                AI.StateMachine.ChangeState("Wander")
            else
                DecideCombatState()
            end
        end
    }


AI.StateMachine.AllStates.Wander = 
{
    GetPulseFrequencyMS = 
        function() 
            return 15000 
        end,

    OnEnterState = 
        function()
            -- DebugMessage("Wander start")
        end,

    AiPulse = 
        function()
            --WanderInRegion(homeRegion,"Wander")
            local homeRegion = this:GetObjVar("homeRegion")
            if (AI.MainTarget == nil) then
                local wanderLoc = this:GetLoc():Project(math.random(0,360), math.random(20,40))
                -- Run to dest
                this:PathTo(wanderLoc,3.0,"Wander")
            else
                DecideCombatState()
            end
        end,

    OnExitState = 
        function()
            following = nil
        end
}

RegisterEventHandler(EventType.Arrived, "Wander",
    function ( ... )
               AI.StateMachine.ChangeState("Howl")
    end)

--If I die then the chain of command breaks down
RegisterEventHandler(EventType.Message, "HasDiedMessage", 
    function ()
    end)

-- Every top level script needs to initialize the ai state machine
AI.Init()